load coords.dat;
load elem.dat;
load points.dat;

[xorig,bl,bu,v,cl,cu] = spamfunc('matf');
ob = [];
gr = [];

bestf = -inf;
bestu = [];
bestk = 0;

perm = find(coords(:,3) == 0);

for b = 1:length(points) / length(coords)

  clf;

  p = points((b-1)*length(coords)+1:b*length(coords));

%  for i = 1:length(elem)
%    x = [coords(elem(i,:),1)' coords(elem(i,1),1)];
%    y = [coords(elem(i,:),2)' coords(elem(i,1),2)];
%    f = [p(elem(i,:))', p(elem(i,1))];
%
%    plot3(x,y,f);
%    % patch(x,y,f);
%    hold on;
%  end

  [fu,c,errs] = spamfunc(p,0);
  [gr,J,errs] = spamfunc(p,1);
  he = spamfunc(zeros(size(cl)));

  ob(b) = fu;
  ng(b) = gr(perm)'*gr(perm);

  if (fu > bestf)
    bestf = fu;
    bestu = p;
    bestk = b;
  end

  hold off;
%  pause;
end

plot(1:b, ob);
pause;
plot(1:b, ng);
pause;

[f,c,errs] = spamfunc(bestu,0);
[g,J,errs] = spamfunc(bestu,1);
H = spamfunc(zeros(size(cl)));

x = bestu;

bestk

iter = 0;
while (norm(g(perm),2) > 1e-6)

  iter = iter + 1;
  d = -H(perm,perm)\g(perm);

  lambda = 1.0;
  while (lambda > 1e-8)
    x(perm) = bestu(perm) + lambda*d;
    [gnew,J,errs] = spamfunc(x,1);
    if (gnew(perm)'*gnew(perm) < g(perm)'*g(perm) + 0.01*lambda*g(perm)'*H(perm,perm)*d)
      break;
    end

    lambda = lambda*0.5;
  end

  bestu(perm) = bestu(perm) + lambda*d;
  [f,c,errs] = spamfunc(bestu,0);
  [g,J,errs] = spamfunc(bestu,1);
  H = spamfunc(zeros(size(cl)));

  [iter, f, norm(g(perm),2), lambda]
  % eigs(H(perm,perm), 4, 'SA')
end

eig(full(H(perm,perm)))
cond(full(H(perm,perm)))

pause;

for i = 1:length(elem)
  x = [coords(elem(i,:),1)' coords(elem(i,1),1)];
  y = [coords(elem(i,:),2)' coords(elem(i,1),2)];
  f = [bestu(elem(i,:))', bestu(elem(i,1))];

  HANDLE = fill3(x,y,f,f);
%  set(HANDLE, 'linestyle', 'none');
  hold on;
end

%shading interp;

